org.apache.commons.math3.stat.descriptive.summary

## Class Sum

- java.lang.Object
- - org.apache.commons.math3.stat.descriptive.AbstractUnivariateStatistic
  - - org.apache.commons.math3.stat.descriptive.AbstractStorelessUnivariateStatistic
    - - org.apache.commons.math3.stat.descriptive.summary.Sum

- All Implemented Interfaces:
    Serializable, StorelessUnivariateStatistic, UnivariateStatistic, MathArrays.Function

      public class Sum
      extends AbstractStorelessUnivariateStatistic
      implements Serializable

  Returns the sum of the available values.

  If there are no values in the dataset, then 0 is returned. If any of the values are `NaN`, then `NaN` is returned.

  Note that this implementation is not synchronized. If multiple threads access an instance of this class concurrently, and at least one of the threads invokes the `increment()` or `clear()` method, it must be synchronized externally.

  Version:
    $Id: Sum.java 1416643 2012-12-03 19:37:14Z tn $
  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private long` | `n`
    `private static long` | `serialVersionUID` Serializable version identifier
    `private double` | `value` The currently running sum.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Sum()` Create a Sum instance
    `Sum(Sum original)` Copy constructor, creates a new `Sum` identical to the `original`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `clear()` Clears the internal state of the Statistic
    `Sum` | `copy()` Returns a copy of the statistic with the same internal state.
    `static void` | `copy(Sum source, Sum dest)` Copies source to dest.
    `double` | `evaluate(double[] values, double[] weights)` The weighted sum of the entries in the the input array.
    `double` | `evaluate(double[] values, double[] weights, int begin, int length)` The weighted sum of the entries in the specified portion of the input array, or 0 if the designated subarray is empty.
    `double` | `evaluate(double[] values, int begin, int length)` The sum of the entries in the specified portion of the input array, or 0 if the designated subarray is empty.
    `long` | `getN()` Returns the number of values that have been added.
    `double` | `getResult()` Returns the current value of the Statistic.
    `void` | `increment(double d)` Updates the internal state of the statistic to reflect the addition of the new value.

    - ### Methods inherited from class org.apache.commons.math3.stat.descriptive.AbstractStorelessUnivariateStatistic

      `equals, evaluate, hashCode, incrementAll, incrementAll`

    - ### Methods inherited from class org.apache.commons.math3.stat.descriptive.AbstractUnivariateStatistic

      `evaluate, getData, getDataRef, setData, setData, test, test, test, test`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### serialVersionUID

          private static final long serialVersionUID

      Serializable version identifier
      See Also:
        Constant Field Values

    - #### n

          private long n

    - #### value

          private double value

      The currently running sum.

  - ### Constructor Detail

    - #### Sum

          public Sum()

      Create a Sum instance

    - #### Sum

          public Sum(Sum original)
              throws NullArgumentException

      Copy constructor, creates a new `Sum` identical to the `original`
      Parameters:
        `original` - the `Sum` instance to copy
      Throws:
        `NullArgumentException` - if original is null

  - ### Method Detail

    - #### increment

          public void increment(double d)

      Updates the internal state of the statistic to reflect the addition of the new value.
      Specified by:
        `increment` in interface `StorelessUnivariateStatistic`
      Specified by:
        `increment` in class `AbstractStorelessUnivariateStatistic`
      Parameters:
        `d` - the new value.

    - #### getResult

          public double getResult()

      Returns the current value of the Statistic.
      Specified by:
        `getResult` in interface `StorelessUnivariateStatistic`
      Specified by:
        `getResult` in class `AbstractStorelessUnivariateStatistic`
      Returns:
        value of the statistic, `Double.NaN` if it has been cleared or just instantiated.

    - #### getN

          public long getN()

      Returns the number of values that have been added.
      Specified by:
        `getN` in interface `StorelessUnivariateStatistic`
      Returns:
        the number of values.

    - #### clear

          public void clear()

      Clears the internal state of the Statistic
      Specified by:
        `clear` in interface `StorelessUnivariateStatistic`
      Specified by:
        `clear` in class `AbstractStorelessUnivariateStatistic`

    - #### evaluate

          public double evaluate(double[] values,
                        int begin,
                        int length)
                          throws MathIllegalArgumentException

      The sum of the entries in the specified portion of the input array, or 0 if the designated subarray is empty.

      Throws `MathIllegalArgumentException` if the array is null.

      Specified by:
        `evaluate` in interface `UnivariateStatistic`
      Specified by:
        `evaluate` in interface `MathArrays.Function`
      Overrides:
        `evaluate` in class `AbstractStorelessUnivariateStatistic`
      Parameters:
        `values` - the input array
        `begin` - index of the first array element to include
        `length` - the number of elements to include
      Returns:
        the sum of the values or 0 if length = 0
      Throws:
        `MathIllegalArgumentException` - if the array is null or the array index parameters are not valid
      See Also:
        `UnivariateStatistic.evaluate(double[], int, int)`

    - #### evaluate

          public double evaluate(double[] values,
                        double[] weights,
                        int begin,
                        int length)
                          throws MathIllegalArgumentException

      The weighted sum of the entries in the specified portion of the input array, or 0 if the designated subarray is empty.

      Throws `MathIllegalArgumentException` if any of the following are true:

      - the values array is null
      - the weights array is null
      - the weights array does not have the same length as the values array
      - the weights array contains one or more infinite values
      - the weights array contains one or more NaN values
      - the weights array contains negative values
      - the start and length arguments do not determine a valid array

      Uses the formula,

              weighted sum = Σ(values[i] * weights[i])

      Parameters:
        `values` - the input array
        `weights` - the weights array
        `begin` - index of the first array element to include
        `length` - the number of elements to include
      Returns:
        the sum of the values or 0 if length = 0
      Throws:
        `MathIllegalArgumentException` - if the parameters are not valid
      Since:
        2.1

    - #### evaluate

          public double evaluate(double[] values,
                        double[] weights)
                          throws MathIllegalArgumentException

      The weighted sum of the entries in the the input array.

      Throws `MathIllegalArgumentException` if any of the following are true:

      - the values array is null
      - the weights array is null
      - the weights array does not have the same length as the values array
      - the weights array contains one or more infinite values
      - the weights array contains one or more NaN values
      - the weights array contains negative values

      Uses the formula,

              weighted sum = Σ(values[i] * weights[i])

      Parameters:
        `values` - the input array
        `weights` - the weights array
      Returns:
        the sum of the values or Double.NaN if length = 0
      Throws:
        `MathIllegalArgumentException` - if the parameters are not valid
      Since:
        2.1

    - #### copy

          public Sum copy()

      Returns a copy of the statistic with the same internal state.
      Specified by:
        `copy` in interface `StorelessUnivariateStatistic`
      Specified by:
        `copy` in interface `UnivariateStatistic`
      Specified by:
        `copy` in class `AbstractStorelessUnivariateStatistic`
      Returns:
        a copy of the statistic

    - #### copy

          public static void copy(Sum source,
                  Sum dest)
                           throws NullArgumentException

      Copies source to dest.

      Neither source nor dest can be null.

      Parameters:
        `source` - Sum to copy
        `dest` - Sum to copy to
      Throws:
        `NullArgumentException` - if either source or dest is null

Copyright (c) 2003-2013 Apache Software Foundation